/*
    VM_TOUR.PRG
*/

#define K_F9    -8
#define K_F10   -9
#define DEMO_TOP        2
#define DEMO_LEFT       4
#define DEMO_MENU       {;
                            "On the Cover",;
                            "News",;
                            "Test Drives",;
                            "Features",;
                            "The Experts",;
                            "Application Development",;
                            "The Basics",;
                            "Departments";
                        }
#define DEMO_TRIGGER    { 8,1,1,1,5,1,5,1 }
memvar _brun

//---------
func main()
local nTop := 4, nLeft := 0
local aMenu := {;
                    "Overview: What's The Vertical Menu Collection?",;
                    "The Vertical Menu Engine Syntax",;
                    "Demo: The Basic Implementation",;
                    "Configuring the Menu Engine with the APIs()",;
                    "Demos: Changing the Its Looks",;
                    "Demos: Extending Its Functionality",;
                    "A Quick Syntax Reference";
               }
local aTrigger := { 1,26,11,1,25,22,16 }
local aBlock := {;
                    {|e| ADviewfile( "overview.vm" )},;
                    {|e| ADviewfile( "syntax.vm" )},;
                    {|e| ADviewfile( "vm_demo1.prg", {||Xdemo1()} )},;
                    {|e| ADviewfile( "config.vm" )},;
                    {|e| Xlooks(e)},;
                    {|e| Xfunction(e)},;
                    {|e| ADviewfile( "quickref.vm" )};
                }

Xintro()
ADvermenu( nTop, nLeft, aMenu, aTrigger, aBlock )
ADcredit( 14,0 )
return nil


//------------
func Xlooks(e)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 4
local aMenu := {;
                    "Adding a Header",;
                    "Greying the Backgound",;
                    "Pointing the Current Selection With an Arrow",;
                    "Displaying Option-Sensitive Messages";
               }
local xBlock := {;
                    {|e| ADviewfile( "vm_demo2.prg", {||Xdemo2()} )},;
                    {|e| ADviewfile( "vm_demo3.prg", {||Xdemo3()} )},;
                    {|e| ADviewfile( "vm_demo4.prg", {||Xdemo4()} )},;
                    {|e| ADviewfile( "vm_demo5.prg", {||Xdemo5()} )},;
                }
ADvermenu( nTop, nLeft, aMenu,, xBlock )
return nil


//------------
func Xfunction(e)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 4
local aMenu := {;
                    "Taglist",;
                    "Restricted Taglist",;
                    "User-Defined Hot Keys",;
                    "User-Defined Hot Spots",;
                    "Cascading Menus";
               }
local xBlock := {;
                    {|e| ADviewfile( "vm_demo6.prg", {||Xdemo6()} )},;
                    {|e| ADviewfile( "vm_demo7.prg", {||Xdemo7()} )},;
                    {|e| ADviewfile( "vm_demo8.prg", {||Xdemo8()} )},;
                    {|e| ADviewfile( "vm_demo9.prg", {||Xdemo9()} )},;
                    {|e| ADviewfile( "vm_demo10.prg", {||Xdemo10()} )},;
                }
ADvermenu( nTop, nLeft, aMenu, {1,1,18,18,1}, xBlock )
return nil

/*
//---------------------------
func Xviewfile( cFile, bRun )
local aScn := ADsavescn( 0,0,24,79 )
local cColor := setcolor( if( iscolor(), "W+/G", "W/N" ) )
local cPrompt1 := "Esc:CloseWindow"
local cPrompt2 := "Esc:CloseWindow   F10:RunDemo"
priv _bRun

if !file( cFile )
else
    ADbox( 0,0,23,79,,, .f., .f. )
    setpos( 24, 0 )
    dispout( space(80), "N/W" )

    if bRun = nil
        setpos( 24, int( ( 80 - len( cPrompt1 ) ) / 2 ) )
        dispout( cPrompt1, "N/W" )
        memoedit( memoread( cFile ), 1,2,22,77, .f. )
    else
        _bRun = bRun
        setpos( 24, int( ( 80 - len( cPrompt2 ) ) / 2 ) )
        dispout( cPrompt2, "N/W" )
        memoedit( memoread( cFile ), 1,2,22,77, .f., "Xmemorun" )
    endif

    ADrestscn( aScn )
endif

setcolor( cColor )
return nil


//--------------------------------
func Xmemorun( nMode, nRow, nCol )
if lastkey() = K_F10
    eval( _bRun )
    ADmessage({"Press any key"},,,.f.)
endif
return 0
*/

//-----------
func Xdemo1()
cls
Xinfo1()
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( {"You selected: " + DEMO_MENU[n]} )} )
return nil

//----------
func Xinfo1()
ADmessage( {;
                "Press any of the highlighted trigger keys to make a",;
                "selection, or you may click it with the mouse left",;
                "button.",;
                "",;
                "Press the Esc key, or click the right button to abort.";
           }, 14,, .F. )
return nil


//-----------
func Xdemo2()
cls
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( {"You selected: " + DEMO_MENU[n]} )},;
           {|e| ADvm_header( e, "Databased Advisor Sections" )};
         )
return nil

//-----------
func Xdemo3()
local aScn
local bDispBegin := {|e| aScn := ADchgcolor( 0,0,24,79, "W/N" )}
local bDispEnd := {|e| nil}
local bUndisplay := {|e| ADrestscn( aScn )}

ADmessage( { "ADvermenu() will 'grey' the screen before displaying the menu.",;
             "It will restore the original screen at exit.",;
             "Press any key" },,, .f. )
ADwait()
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( {"You selected: " + DEMO_MENU[n]} )},;
           {|e| ADvm_extra( e, bDispBegin, bDispEnd, bUndisplay )};
         )
return nil

//-----------
func Xdemo4()
local nRow, aScn, cStdColor
local bMoveBegin := {|e| ADrestscn( aScn )}
local bMoveEnd := {|e| nRow := ADvm_row(e),;
                       setpos( nRow, DEMO_LEFT + 1 ),;
                       aScn := ADsavescn( nRow, DEMO_LEFT+1, nRow, DEMO_LEFT+1 ),;
                       dispout( "", cStdColor );
                  }
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( {"You selected: " + DEMO_MENU[n]} )},;
           {|e| cStdColor := ADvm_color(e)[1],;
                ADvm_color( e, { , cSTdColor } ),;
                ADvm_move( e, bMoveBegin, bMoveEnd )};
         )
return nil

//-----------
func Xdemo5()
local aMsg := {;
                    { "Cover story" },;
                    { "Late breaking news" },;
                    { "Reviews of new products" },;
                    { "Selected features" },;
                    { "Tips from database experts" },;
                    { "Tips from professional developers" },;
                    { "Database fundamentals" },;
                    { "Regular features" };
              }
local nRow, nRight, nCurrent, aScn
local bMoveBegin := {|e| ADrestscn( aScn )}
local bMoveEnd := {|e| nRow := ADvm_row(e),;
                       nRight := ADvm_right( e ),;
                       nCurrent := ADvm_current( e ),;
                       aScn := ADmessage( aMsg[nCurrent], nRow, nRight+2, .f., .f. );
                  }
local bEscape := {|e| ADrestscn( aScn ), ADvm_exit(e)}
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( {"You selected: " + DEMO_MENU[n]} )},;
           {|e| ADvm_escape( e, bEscape ),;
                ADvm_move( e, bMoveBegin, bMoveEnd )};
         )
return nil


//---------
func Xdemo6()
Xinfo6()
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,a| aeval( a, {|x| ADmessage( { DEMO_MENU[x] } )} )},;
           {|e| ADvm_taglist( e ) };
         )
return nil

//----------
func Xinfo6()
ADmessage( {;
                "This ADvermenu is a taglist.  Press the Spacebar or",;
                "click an option with the left button to tag/untag it.",;
                "Press the Enter key or click the left button outside",;
                "the box to select all tagged options.  The return",;
                "value is an array of selected options.";
           }, 14,, .f. )
return nil

//---------
func Xdemo7()
Xinfo7()
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,a| aeval( a, {|x| ADmessage( { DEMO_MENU[x] } )} )},;
           {|e| ADvm_taglist( e, "123" ) };
         )
return nil

//----------
func Xinfo7()
ADmessage( {;
                "This ADvermenu is a restricted taglist.  You can only",;
                "select a maximum of three options.  Tag them with '1',",;
                "'2', or '3', or click them with the left button.  The",;
                "return value is a sorted array of selections";
           }, 14,, .f. )
return nil


//---------
func Xdemo8()
Xinfo8()
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( { DEMO_MENU[n] } )},;
           {|e| ADvm_keys( e, { K_F9, K_F10 }, {|e,n,k| Xkeys(n,k)} )};
         )
return nil


//---------------------
func Xkeys( nth, nKey )

if nth = 1      // or nKey = K_F9
    ADmessage( { "Pressed F9" } )
elseif nth = 2  // or nKey = K_F10
    ADmessage( { "Pressed F10" } )
endif
return nil


//----------
func Xinfo8()
ADmessage( {;
                "In this ADvermenu, F9 and F10 have been defined as",;
                "hot keys.";
           }, 14,, .f. )
return nil

#define SCN_TOP     {0,0,0,79}
#define SCN_BOTTOM  {24,0,24,79}

//---------
func Xdemo9()
Xinfo9()
ADvermenu( DEMO_TOP, DEMO_LEFT, DEMO_MENU, DEMO_TRIGGER,;
           {|e,n| ADmessage( { DEMO_MENU[n] } )},;
           {|e| ADvm_lbuttons( e, { SCN_TOP, SCN_BOTTOM },;
                                    {|e,n,r,c| Xlbuttons(n)} )};
         )
return nil


//-------------------
func Xlbuttons( nth )

if nth = 1
    ADmessage( { "Clicked the top of the screen" } )
elseif nth = 2
    ADmessage( { "Clicked the bottom of the screen" } )
endif
return nil


//----------
func Xinfo9()
ADmessage( {;
                "In this ADvermenu, the top and the bottom of the",;
                "screen have been defined as left button hot spots.";
           }, 14,, .f. )
return nil

//---------
func Xdemo10()
local nTop := 0, nLeft := 10
local aMenu := {;
                    "News",;
                    "Test Drives",;
                    "Features";
               }
local aTrigger := { 1,1,1 }
local aBlock := {;
                    {|e,n| Xnews(e,n)},;
                    {|e,n| Xtest(e,n)},;
                    {|e,n| Xfeatures(e,n)};
                }

cls
Xinfo10()
ADvermenu( nTop, nLeft, aMenu, aTrigger, aBlock )
return nil


//----------------
func Xnews(e,n)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 5
local aMenu := {;
                    "Dataline",;
                    "Editor on the Go",;
                    "Database Confidential";
               }
local aTrigger := { 1,1,10 }
ADvermenu( nTop, nLeft, aMenu, aTrigger )
return nil


//----------------
func Xtest(e,n)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 5
local aMenu := {;
                    "New!",;
                    "Update",;
                    "Field Report";
               }
local aTrigger := { 1,1,1 }
ADvermenu( nTop, nLeft, aMenu, aTrigger )
return nil


//----------------
func Xfeatures(e,n)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 5
local aMenu := {;
                    "Object-Oriented Programming",;
                    "First Look";
               }
local aTrigger := { 1,1 }
local aBlock := {;
                    {|e,n| Xoop(e,n)},;
                    {|e,n| nil};
                }
ADvermenu( nTop, nLeft, aMenu, aTrigger, aBlock )
return nil



//----------------
func Xoop(e,n)
local nTop := ADvm_row(e) + 1, nLeft := ADvm_left(e) + 5
local aMenu := {;
                    "The Oop Primer for Xbase Programmers",;
                    "Oop: What's the Next Step?";
               }
local aTrigger := { 9,17 }
ADvermenu( nTop, nLeft, aMenu, aTrigger )
return nil

//----------
func Xinfo10()
ADmessage( {;
                "Implementation of cascading menus is a breeze.";
           }, 14,, .f. )
return nil


//-----------
func Xintro()
cls
ADmessage( {;
                "The Vertical Menu Collection v1.2",;
                "A Mouseable and Extensible Menu Engine and APIs",;
                "",;
                "",;
                "Copyright (c) The Programmer's Desk, 1992",;
                "Press any key";
           },,, .f. )
ADwait()
return nil

